package	jp.co.sds_corp.util.common;

import java.io.Serializable;
import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class JsonData implements Serializable
{
	private static final long serialVersionUID = 1L;
	Map<String,Object>	map = new HashMap<String,Object>();
	String	buf;

	public JsonData() {
	}

	public static JsonData parse( String var ) throws ParseException {
		JsonData ret = new JsonData();
		if ( ret.parseArray( var ) ) {
			return ret;
		}

		if ( ret.parseObject( var ) ) {
			return ret;
		}
		throw( new ParseException( "can't parse", -1 ));
	}

	private boolean parseArray( String var ) throws ParseException {
		String key, val;
		String sptn1 = "\\{\"(.*?)\":\\[(.*?)\\]\\}";
		Pattern pattern = Pattern.compile( sptn1 );
		Matcher matcher = pattern.matcher( var );
		if ( !matcher.find()) {
			return false;
		}
		key = matcher.group( 1 );
		val = matcher.group( 2 );

		List<JsonData> list = new Vector<JsonData>();
		String sptn2 = "(\\{.*?\\}),*";
		pattern = Pattern.compile( sptn2 );
		matcher = pattern.matcher( val );
		for ( ;; ) {
			if ( !matcher.find()) {
				break;
			}
			JsonData data = new JsonData();
			if ( !data.parseObject( matcher.group( 1 )) ) {
				continue;
			}
			list.add( data );
		}
		map.put( key, list );
		return true;
	}

	private boolean parseObject( String var ) throws ParseException {
		String key, val;
		String sptn1 = "\\{(\".*\")\\}";
		Pattern pattern = Pattern.compile( sptn1 );
		Matcher matcher = pattern.matcher( var );
		if ( !matcher.find()) {
			return false;
		}
		val = matcher.group( 1 );

		String sptn2 = "\"(.*?)\":\"(.*?)\",*";
		pattern = Pattern.compile( sptn2 );
		matcher = pattern.matcher( val );
		for ( ;; ) {
			if ( !matcher.find()) {
				break;
			}
			key = matcher.group( 1 );
			val = matcher.group( 2 );
			map.put( key, val );
		}
		return true;
	}

	public Map getValueMap() {
		return map;
	}

	public List getList( String key ) {
		return (List )map.get( key );
	}

	public String getValue( String key ) {
		return (String )map.get( key );
	}

	public int getIntValue( String key ) throws NumberFormatException {
		String val = (String )map.get( key );
		return Integer.valueOf( val ).intValue();
	}

	public double getDoubleValue( String key ) throws NumberFormatException {
		String val = (String )map.get( key );
		return Double.valueOf( val ).doubleValue();
	}

	public String toString() {
		return map.toString();
	}

}
