package	jp.co.sds_corp.util.config;

/**
* 設定ファイルにエラーがあった場合に発生します。
*/
public class ConfigurationFormatException extends Exception
{
	private static final long serialVersionUID = 1L;

	public ConfigurationFormatException(
                        String key, String value ) {
        super( createMessage( key, value ));
    }
    public ConfigurationFormatException(
                        String key, String value, Exception original ) {
        super( createMessage( key, value ), original );
    }

    private static String createMessage( String key, String value ) {
        return "Configuration key [" + key + "] is error.\n" +
                "Specified value is [" + value + "].\n";
    }
}
