package	jp.co.sds_corp.util.log;

import java.util.logging.Formatter;
import java.util.logging.LogManager;
import java.util.logging.LogRecord;

public class FixedFormatter extends Formatter
{
	boolean	bDesc = false;

	public FixedFormatter() {
		super();
		LogManager manager = LogManager.getLogManager();
		String var;
		var = manager.getProperty( "jp.co.sds_corp.util.log.FixedrFormatter.desc" );
		if ( var != null && var.equals( "true" )) {
			bDesc = true;
		}
	}

	public String format( LogRecord record ) {
		StringBuilder ret = new StringBuilder();
		String[] arrName = record.getLoggerName().split( "\\." );
		String	category = arrName[arrName.length-1];
		if ( bDesc ) {
			ret.append( String.format(
				"%tF %1$tT.%1$tL [%s %s] (%s#%s) %s%n",
					record.getMillis(),
					record.getLevel(),
					category,
					record.getSourceClassName(), record.getSourceMethodName(),
					record.getMessage()));
		} else {
			ret.append( String.format(
				"%tF %1$tT.%1$tL [%s %s] %s%n",
					record.getMillis(),
					record.getLevel(),
					category,
					record.getMessage()));
		}
		Throwable thr = record.getThrown();
		if ( thr != null ) {
			ret.append( thr.toString() + "\n" );
			Throwable ex = thr;
			for ( ;; ) {
				StackTraceElement[] stacks = ex.getStackTrace();
				for ( StackTraceElement stack : stacks ) {
					ret.append( "\t" + stack.toString() + "\n" );
				}
				ex = ex.getCause();
				if ( ex == null ) {
					break;
				}
				ret.append( "Caused by: " + ex.toString() + "\n" );
			}
		}
		return ret.toString();
	}

}

