package jp.co.sds_corp.util.charset;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class CharsetTest extends BasicTestCase
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	CharsetChecker checker;

	public void setUp() throws Exception {
		super.setUp();
		checker = new CharsetChecker();
	}

	public void test1() throws Exception {
		String filename = "target/test-classes/charset_test1.txt";
		try {
			checker.check(filename, "UTF-8", "Windows-31J");
		} catch (Exception ex) {
			logger.error(this, "error.", ex);
			throw(ex);
		}
	}

	public void testErr1() throws Exception {
		String filename = "target/test-classes/charset_test1.txt";
		try {
			checker.check(filename, "UTF-8", "ISO-2022-JP");
		} catch (Exception ex) {
			assertEquals("message", "convert error. line=1", ex.getMessage());
			assertEquals("cause.message", "encode error. UNMAPPABLE[1] (3:1) \"123[－]あいうえお\"", ex.getCause().getMessage());

			logger.debug(this, "expected.", ex);
		}
	}

}
